poj 1113 凸包+简单几何计算

2024-09-09 16:32

本文主要是介绍poj 1113 凸包+简单几何计算,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题意:

给N个平面上的点,现在要在离点外L米处建城墙,使得城墙把所有点都包含进去且城墙的长度最短。


解析:

韬哥出的某次训练赛上A出的第一道计算几何,算是大水题吧。

用convexhull算法把凸包求出来,然后加加减减就A了。

计算见下图:

好久没玩画图了啊好开心。


代码:

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <cmath>
#include <stack>
#include <vector>
#include <queue>
#include <map>#define LL long longusing namespace std;
const int maxn = 1e3 + 10;
const int inf = 0x3f3f3f3f;
const double eps = 1e-10;
const double pi = 4 * atan(1.0);struct Point
{double x, y;Point(double x = 0, double y = 0) : x(x), y(y){}
};typedef Point Vector;Vector operator + (Vector A, Vector B)
{return Vector(A.x + B.x, A.y + B.y);
}Vector operator - (Vector A, Vector B)
{return Vector(A.x - B.x, A.y - B.y);
}Vector operator * (Vector A, double p)
{return Vector(A.x * p, A.y * p);
}Vector operator / (Vector A, double p)
{return Vector(A.x / p, A.y / p);
}bool operator < (const Point& a, const Point& b)
{return a.x < b.x || (a.x == b.x && a.y < b.y);
}int dcmp(double x)
{if (fabs(x) < eps){return 0;}else{return x < 0 ? -1 : 1;}
}bool operator == (const Point& a, const Point& b)
{return dcmp(a.x - b.x) == 0 && dcmp(a.y - b.y) == 0;
}double Dot(Vector A, Vector B)
{return A.x * B.x + A.y * B.y;
}double Length(Vector A)
{return sqrt(Dot(A, A));
}double Angle(Vector A, Vector B)
{return acos(Dot(A, B) / Length(A) / Length(B));
}double Cross(Vector A, Vector B)
{return A.x * B.y - A.y * B.x;
}double Area2(Point A, Point B, Point C)
{return Cross(B - A, C - A);
}bool cmp(Point A, Point B)
{if (A.x == B.x)return A.y < B.y;return A.x < B.x;
}int ConvexHull(Point* p, int n, Point* ch)
{sort(p, p + n, cmp);int m = 0;for (int i = 0; i < n; i++){while (m > 1 && Cross(ch[m - 1] - ch[m - 2], p[i] - ch[m - 2]) <= 0)m--;ch[m++] = p[i];}int k = m;for (int i = n - 2; i >= 0; i--){while (m > k && Cross(ch[m - 1] - ch[m - 2], p[i] - ch[m - 2]) <= 0)m--;ch[m++] = p[i];}if (n > 1)m--;return m;
}int main()
{#ifdef LOCALfreopen("in.txt", "r", stdin);#endif // LOCALint n;double l;while (scanf("%d%lf", &n, &l) == 2){Point p[maxn];for (int i = 0; i < n; i++){scanf("%lf%lf", &p[i].x, &p[i].y);}Point ch[maxn];int index = ConvexHull(p, n, ch);
//        for (int i = 0; i < index; i++)
//            cout << ch[i].x << " " << ch[i].y << endl;Vector g[maxn];double angle = 0;double ans = 0;for (int i = 0; i < index - 1; i++){g[i].x = ch[i + 1].x - ch[i].x;g[i].y = ch[i + 1].y - ch[i].y;ans += Length(g[i]);}g[index - 1].x = ch[0].x - ch[index - 1].x;g[index - 1].y = ch[0].y - ch[index - 1].y;ans += Length(g[index - 1]);//cout << ans << endl;for (int i = 0; i < index - 1; i++){angle += Angle(g[i], g[i + 1]);}angle += Angle(g[index - 1], g[0]);//cout << angle << endl;ans += pi * l * angle / pi;printf("%.lf\n", ans);}return 0;
}


这篇关于poj 1113 凸包+简单几何计算的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1151689

相关文章

csu 1446 Problem J Modified LCS (扩展欧几里得算法的简单应用)

这是一道扩展欧几里得算法的简单应用题,这题是在湖南多校训练赛中队友ac的一道题,在比赛之后请教了队友,然后自己把它a掉 这也是自己独自做扩展欧几里得算法的题目 题意:把题意转变下就变成了:求d1*x - d2*y = f2 - f1的解,很明显用exgcd来解 下面介绍一下exgcd的一些知识点:求ax + by = c的解 一、首先求ax + by = gcd(a,b)的解 这个

hdu2289(简单二分)

虽说是简单二分,但是我还是wa死了  题意:已知圆台的体积,求高度 首先要知道圆台体积怎么求:设上下底的半径分别为r1,r2,高为h,V = PI*(r1*r1+r1*r2+r2*r2)*h/3 然后以h进行二分 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#includ

usaco 1.3 Prime Cryptarithm(简单哈希表暴搜剪枝)

思路: 1. 用一个 hash[ ] 数组存放输入的数字,令 hash[ tmp ]=1 。 2. 一个自定义函数 check( ) ,检查各位是否为输入的数字。 3. 暴搜。第一行数从 100到999,第二行数从 10到99。 4. 剪枝。 代码: /*ID: who jayLANG: C++TASK: crypt1*/#include<stdio.h>bool h

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D